/*************************************************
 **                                             **
 **   idx.h                                 		**
 **                                             **
 **    			Copyright (C) 1990, 1991 by  				**
 **               SoftC, Ltd.                   **
 **               16820 3rd St NE               **
 **               Ham Lake, MN 55304            **
 **               (612) 434-6968                **
 **                                             **
 **             All rights reserved.            **
 *************************************************/



#ifndef __SOFTC_H__
#include "softc.h"
#endif



/**********
 *
 *  Type Definitions
 *
 **********/




typedef struct {  /* FoxBASE index file information packet */
  CHAR fname[80]; /* file name */
  CHAR keytype;   /* key type ('C' Character, 'N' Date/Numeric) */
  CHAR keylen;    /* key length */
  INT exprlen;    /* key expression length */
  SC_FLAGS flags; /* miscellaneous flags */
} SC_IDXINFO;



#ifdef __cplusplus
extern "C" {
#endif


/**********
 *
 *  FoxBASE+/FoxPro Index File Manipulators Prototypes
 *
 **********/




INT scdibfrsz(  INT,              /* index file handle */
                INT *,            /* buffer length in pages */
                INT );            /* set or get buffer length */

INT scdiclose(  INT );            /* file handle */

INT scdicreate( CHAR *,           /* filename */
                INT,              /* index key type */
                CHAR *,           /* key expression */
                INT );            /* key length */

INT scdiexpr(   INT,              /* file handle */
                CHAR * );         /* key expression */

INT scdiflush(  INT );            /* file handle */

INT scdihget(   INT );            /* file handle */

INT scdiindex(  INT,              /* data file handle */
                CHAR *,           /* new file name */
                INT,              /* index key type */
                CHAR *,           /* key expression */
                INT );            /* key length */

INT scdiinfo(   INT,              /* file handle */
                SC_IDXINFO * );   /* file information and status */

INT scdiopenx(  INT *,            /* file handle */
                CHAR *,           /* filename */
                INT );            /* open mode and characteristics */




/**********
 *
 *  FoxBASE+/FoxPro Index Key Building Prototypes
 *
 **********/




INT scdikdate(  CHAR *,           /* FoxBASE date */
                CHAR *,           /* date string */
                INT );            /* date string format type */

INT scdikmake(  INT,              /* .DBF file handle */
                INT,              /* .NTX file handle */
                VOID ** );        /* index key */

INT scdiknum(   CHAR *,           /* FoxBASE DOUBLE */
                DOUBLE );         /* C DOUBLE */






/**********
 *
 *  FoxBASE+/FoxPro Index Key Manipulator Prototypes
 *
 **********/




INT scdikadd(   INT,              /* file handle */
                VOID *,           /* key string */
                LONG );           /* data record number */

INT scdikbot(   INT,              /* file handle */
                VOID *,           /* key string */
                LONG *);          /* data record number */

INT scdikcur(   INT,              /* file handle */
                VOID *,           /* key string */
                LONG *);          /* data record number */

INT scdikdel(   INT,              /* file handle */
                VOID *,           /* key string */
                LONG );           /* data record number */

INT scdikfind(  INT,              /* file handle */
                VOID *,           /* key string */
                LONG *,           /* data record number */
                INT);             /* exact match or first */

INT scdiknext(  INT,              /* file handle */
                VOID *,           /* key string */
                LONG *);          /* data record number */

INT scdikprev(  INT,              /* file handle */
                VOID *,           /* key string */
                LONG *);          /* data record number */

INT scdiktop(   INT,              /* file handle */
                VOID *,           /* key string */
                LONG *);          /* data record number */





#ifdef __cplusplus
}
#endif


